=== debian/changelog ===
spring (101.0+dfsg-2) unstable; urgency=medium

  * Move all Java dependencies from Build-Depends-Indep to Build-Depends
    to prevent a mysterious FTBFS.

 -- Markus Koschany <apo@debian.org>  Sun, 06 Mar 2016 01:41:00 +0100

spring (101.0+dfsg-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * make generated .sdz (zip) archives reproducible.

  [ Markus Koschany ]
  * Imported Upstream version 101.0+dfsg.
  * Drop spring-dbg and use the new spring-dbgsym package instead.
  * Declare compliance with Debian Policy 3.9.7.
  * Update my e-mail address.
  * Vcs fields: Use https.
  * Drop remove-ThreadPool-test.patch. Fixed upstream.
  * Rebase sdl-debian.patch for new release.
  * debian/rules: Set PRD_JSONCPP_INTERNAL to FALSE and use Debian's version of
    jsoncpp.
  * Update get-orig-source target: Include pr-downloader. The pr-downloader is
    mandatory to build Spring now.
  * debian/control: New build-dependencies libcurl4-gnutls-dev and
    libjsoncpp-dev.
  * Install pr-downloader to /usr/games.
  * Install new Shard AI and examples to /usr/share/games/spring.
  * Update debian/copyright for new release.

 -- Markus Koschany <apo@debian.org>  Sat, 05 Mar 2016 22:42:24 +0100
